<template>
    <div>
        <div class="tabs help-tabs">
            <ul>
                <li :class="[ lang === 'boleto' ? 'is-active' : '']"><a @click="lang='boleto'">Boleto</a></li>
                <li :class="[ lang === 'credit_card' ? 'is-active' : '']"><a @click="lang='credit_card'">Cartão de Crédito</a></li>
                <li :class="[ lang === 'on_delivery' ? 'is-active' : '']"><a @click="lang='on_delivery'">Pagar na Entrega</a></li>
            </ul>
        </div>
        <div class="box help-content">
            <div v-if="lang ==='boleto'">
                <div class="field">
                    <p class="control">
                        <button class="button is-info" @click.prevent="storeBoleto">Selecionar</button>
                        <a class="button is-default" @click="$emit('cancel')">Cancelar</a>
                    </p>
                </div>
            </div>
            <div v-if="lang ==='credit_card'">
                <credit-card-field
                    @submit="store"
                />
                <!-- <form action="" method="post" id="payment-form">
                    <div class="field">
                        <label for="card-element">
                        Cartão de crédito ou Débito
                        </label>

                            <inline-credit-card-field
                                v-model="card"
                                :activity="activity"
                                @change="onChange"
                                @valid="onValid"
                                @invalid="onInvalid"
                                @complete="onCompleted"
                            />


                    </div>

                    <div class="field">
                            <p class="control">
                                <button class="button is-info" @click.prevent="store(card)" :disabled="!complete || storing">Adicionar</button>
                                <a class="button is-default" @click="$emit('cancel')">Cancelar</a>
                            </p>
                    </div>
                </form> -->
            </div>
            <div v-if="lang ==='on_delivery'">
                <div class="field">
                    <p class="control">
                        <button class="button is-info" @click.prevent="onDelivery">Selecionar</button>
                        <a class="button is-default" @click="$emit('cancel')">Cancelar</a>
                    </p>
                </div>
            </div>
        </div>



    </div>

</template>
<script>

import { mapGetters } from 'vuex'
import CreditCardField from '@/components/creditcard/CreditCardField'

export default {
  components: {
    CreditCardField
      // InlineCreditCardField: () => import(/* webpackChunkName: "vue-credit-card-field" */'vue-credit-card-field/src/Components/InlineCreditCardField'),
      // CreditCardField: () => import(/* webpackChunkName: "vue-credit-card-field" */'vue-credit-card-field/src/Components/CreditCardField'),
  },

  data() {
      return {
          lang: 'boleto',
          error: false,
          loaded: false,
          activity: false,
          complete: false,
          card: {},
          showActivity: false,
          storing: false,
          paymentMethodAvaliable: null,
      }
  },

  computed: {
      ...mapGetters({
          'addresses': 'address/addresses'
      }),

      address() {
          return this.addresses.find(a => a.default === true)
      }
  },

  mounted(){

  },

  methods: {
    async storeBoleto(){
        try {
            this.load({ type: 'boleto' })
        } catch(e){
            this.$emit('cancel')
        }
    },

    async onDelivery(){
        try {
            this.load({ type: 'on_delivery' })
        } catch(e){
            this.$emit('cancel')
        }
    },

    test(value) {
        console.log(value)
        this.$emit('cancel')
    },

    async store(card)
    {
        this.storing = true
        var me = this
        // var expiration = me.card.expiration.trim().split("/")
        // var expYear = (2000 + parseInt(expiration[1])).toString()
        // var cardNumber = me.card.number.replace(/\s/g, '')
        card = typeof card=="object"? card: {};
        card.brand = card.cardType;
        card.cardholderName = card.cardName;
        card.docType = this.address.customer.doc_type;
        card.docNumber = this.address.customer.cpf_cnpj.replaceAll(".","").replace("-","");
        card.securityCode = card.cardCvv;
        card.paymentMethodId = card.cardType
        card.cardExpirationMonth = card.cardMonth;
        card.cardExpirationYear = card.cardYear;

        window.Mercadopago.createToken(card, function(status, response) {
            if (status == 200 || status == 201) {
                me.load(response)
            } else {
                alert(`payment method info error: ${ JSON.stringify(response) }`);
            }
        })

    },

    async load(data) {
      console.log(data)
      try {
        await this.$axios.$post('/api/payment-methods', data)
          .then((response) => {

            if (!response.error){
                this.$emit('created', response.data)
            } else {
                this.$emit('click', response.data)
                this.$emit('cancel')
            }
          })
      } catch (e) {
        console.log(e)
      }
    },

    onChange() {
        // this.complete = false
    },

    onValid(e) {
        this.activity = true;

        setTimeout(() => {
            this.activity = false;
        }, 1000);
    },

    onCompleted(){
        this.complete = true
    },

    onInvalid() {
        this.complete = false
    }
  }

}
</script>

<style scoped>
.help-content {
        background-color: white !important;
    }
    .help-tabs {
        margin-bottom: 10px !important;
    }
    .tabs li.is-active a {
        border-bottom-color: #000000;
        color: #7763A9;
        border-bottom: 3px solid;
        font-weight: bold;
        text-decoration: none;
    }

    a {
        text-decoration: none !important;
    }

</style>
